# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.admin_business_location_dto import AdminBusinessLocationDTO
from visier_platform_sdk.models.admin_custom_property_dto import AdminCustomPropertyDTO
from visier_platform_sdk.models.admin_home_analysis_by_user_group_dto import AdminHomeAnalysisByUserGroupDTO
from visier_platform_sdk.models.admin_tenant_details_traits_dto import AdminTenantDetailsTraitsDTO
from typing import Optional, Set
from typing_extensions import Self

class AdminTenantManagementAPIGetResponseDTO(BaseModel):
    """
    AdminTenantManagementAPIGetResponseDTO
    """ # noqa: E501
    tenant_code: Optional[StrictStr] = Field(default=None, description="The tenant code of the analytic tenant. For example, \"WFF_j1r~i1o\"", alias="tenantCode")
    tenant_display_name: Optional[StrictStr] = Field(default=None, description="An identifiable tenant name that is displayed within Visier. For example, \"Callisto\".", alias="tenantDisplayName")
    status: Optional[StrictStr] = Field(default=None, description="Whether the tenant is enabled or disabled.")
    provision_date: Optional[StrictStr] = Field(default=None, description="The date that the tenant was created.", alias="provisionDate")
    current_data_version: Optional[StrictStr] = Field(default=None, description="The data version ID that the tenant is using.", alias="currentDataVersion")
    data_version_date: Optional[StrictStr] = Field(default=None, description="The date that the data version was published to production.", alias="dataVersionDate")
    purchased_modules: Optional[List[StrictStr]] = Field(default=None, description="The modules assigned to the analytic tenant.", alias="purchasedModules")
    industry_code: Optional[StrictInt] = Field(default=None, description="The 6-digit NAICS code for the industry to which the analytic tenant belongs.", alias="industryCode")
    primary_business_location: Optional[AdminBusinessLocationDTO] = Field(default=None, description="The primary location of operations or where business is performed. If undefined, it is omitted from the response.", alias="primaryBusinessLocation")
    can_administer_other_tenants: Optional[StrictBool] = Field(default=None, description="If true, the tenant is an administrating tenant.", alias="canAdministerOtherTenants")
    embeddable_domains: Optional[List[StrictStr]] = Field(default=None, description="A comma-separated list of strings that represent the URLs, or domains, in which Visier can be embedded.", alias="embeddableDomains")
    custom_properties: Optional[List[AdminCustomPropertyDTO]] = Field(default=None, description="A set of key-value pairs that represent different customizable properties for the analytic tenant.", alias="customProperties")
    sso_instance_issuers: Optional[List[StrictStr]] = Field(default=None, description="A comma-separated list of strings that represent the issuers for the SSO providers that can authenticate this tenant.", alias="ssoInstanceIssuers")
    vanity_url_name: Optional[StrictStr] = Field(default=None, description="The name of the administrating tenant used in Visier URLs.", alias="vanityUrlName")
    home_analysis_id: Optional[StrictStr] = Field(default=None, description="The unique ID of the analysis that's displayed for this tenant when a user logs in.", alias="homeAnalysisId")
    home_analysis_by_user_group: Optional[List[AdminHomeAnalysisByUserGroupDTO]] = Field(default=None, description="A list of objects representing the analysis displayed to specific user groups when users log in.", alias="homeAnalysisByUserGroup")
    click_through_link: Optional[StrictStr] = Field(default=None, description="The custom URL to redirect users into your portal to see the relevant content. This URL is used for links that are shared by and with your users through the sharing capability or email content.", alias="clickThroughLink")
    click_through_link_enabled: Optional[StrictStr] = Field(default=None, description="Whether the click-through link is enabled or disabled.", alias="clickThroughLinkEnabled")
    default_currency: Optional[StrictStr] = Field(default=None, description="The default currency to show in the application for the tenant.", alias="defaultCurrency")
    allowed_o_auth_idp_url_domains: Optional[List[StrictStr]] = Field(default=None, description="A comma-separated list of strings that represent the URLs, or domains, that are allowed in the idp_url OAuth parameter.", alias="allowedOAuthIdpUrlDomains")
    effective_industry_code: Optional[StrictInt] = Field(default=None, description="The 6-digit NAICS code for the industry to which the analytic tenant belongs. This is calculated from industry codes in the tenant's data if the tenant has business unit data. Not returned if the effective industry code cannot be calculated.", alias="effectiveIndustryCode")
    company_size: Optional[StrictInt] = Field(default=None, description="The latest headcount value for the analytic tenant. Not returned if no headcount data is available.", alias="companySize")
    traits: Optional[AdminTenantDetailsTraitsDTO] = Field(default=None, description="The tenant's traits, including aggregation rights, tenant type, and data profile type.")
    __properties: ClassVar[List[str]] = ["tenantCode", "tenantDisplayName", "status", "provisionDate", "currentDataVersion", "dataVersionDate", "purchasedModules", "industryCode", "primaryBusinessLocation", "canAdministerOtherTenants", "embeddableDomains", "customProperties", "ssoInstanceIssuers", "vanityUrlName", "homeAnalysisId", "homeAnalysisByUserGroup", "clickThroughLink", "clickThroughLinkEnabled", "defaultCurrency", "allowedOAuthIdpUrlDomains", "effectiveIndustryCode", "companySize", "traits"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdminTenantManagementAPIGetResponseDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of primary_business_location
        if self.primary_business_location:
            _dict['primaryBusinessLocation'] = self.primary_business_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in custom_properties (list)
        _items = []
        if self.custom_properties:
            for _item_custom_properties in self.custom_properties:
                if _item_custom_properties:
                    _items.append(_item_custom_properties.to_dict())
            _dict['customProperties'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in home_analysis_by_user_group (list)
        _items = []
        if self.home_analysis_by_user_group:
            for _item_home_analysis_by_user_group in self.home_analysis_by_user_group:
                if _item_home_analysis_by_user_group:
                    _items.append(_item_home_analysis_by_user_group.to_dict())
            _dict['homeAnalysisByUserGroup'] = _items
        # override the default output from pydantic by calling `to_dict()` of traits
        if self.traits:
            _dict['traits'] = self.traits.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdminTenantManagementAPIGetResponseDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenantCode": obj.get("tenantCode"),
            "tenantDisplayName": obj.get("tenantDisplayName"),
            "status": obj.get("status"),
            "provisionDate": obj.get("provisionDate"),
            "currentDataVersion": obj.get("currentDataVersion"),
            "dataVersionDate": obj.get("dataVersionDate"),
            "purchasedModules": obj.get("purchasedModules"),
            "industryCode": obj.get("industryCode"),
            "primaryBusinessLocation": AdminBusinessLocationDTO.from_dict(obj["primaryBusinessLocation"]) if obj.get("primaryBusinessLocation") is not None else None,
            "canAdministerOtherTenants": obj.get("canAdministerOtherTenants"),
            "embeddableDomains": obj.get("embeddableDomains"),
            "customProperties": [AdminCustomPropertyDTO.from_dict(_item) for _item in obj["customProperties"]] if obj.get("customProperties") is not None else None,
            "ssoInstanceIssuers": obj.get("ssoInstanceIssuers"),
            "vanityUrlName": obj.get("vanityUrlName"),
            "homeAnalysisId": obj.get("homeAnalysisId"),
            "homeAnalysisByUserGroup": [AdminHomeAnalysisByUserGroupDTO.from_dict(_item) for _item in obj["homeAnalysisByUserGroup"]] if obj.get("homeAnalysisByUserGroup") is not None else None,
            "clickThroughLink": obj.get("clickThroughLink"),
            "clickThroughLinkEnabled": obj.get("clickThroughLinkEnabled"),
            "defaultCurrency": obj.get("defaultCurrency"),
            "allowedOAuthIdpUrlDomains": obj.get("allowedOAuthIdpUrlDomains"),
            "effectiveIndustryCode": obj.get("effectiveIndustryCode"),
            "companySize": obj.get("companySize"),
            "traits": AdminTenantDetailsTraitsDTO.from_dict(obj["traits"]) if obj.get("traits") is not None else None
        })
        return _obj


