# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.designer_api_dimension_filter_dto import DesignerApiDimensionFilterDTO
from typing import Optional, Set
from typing_extensions import Self

class DesignerApiAnalyticObjectFilterDTO(BaseModel):
    """
    DesignerApiAnalyticObjectFilterDTO
    """ # noqa: E501
    analytic_object_uuid: Optional[StrictStr] = Field(default=None, description="The UUID of the analytic object used in the selection concept.", alias="analyticObjectUuid")
    symbol_name: Optional[StrictStr] = Field(default=None, description="The symbol name of the analytic object.", alias="symbolName")
    dimensions: Optional[List[DesignerApiDimensionFilterDTO]] = Field(default=None, description="A list of dimensions included in the concept.")
    __properties: ClassVar[List[str]] = ["analyticObjectUuid", "symbolName", "dimensions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DesignerApiAnalyticObjectFilterDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in dimensions (list)
        _items = []
        if self.dimensions:
            for _item_dimensions in self.dimensions:
                if _item_dimensions:
                    _items.append(_item_dimensions.to_dict())
            _dict['dimensions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DesignerApiAnalyticObjectFilterDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "analyticObjectUuid": obj.get("analyticObjectUuid"),
            "symbolName": obj.get("symbolName"),
            "dimensions": [DesignerApiDimensionFilterDTO.from_dict(_item) for _item in obj["dimensions"]] if obj.get("dimensions") is not None else None
        })
        return _obj


