# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1914
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ServicingProfileAssignedForAccessibleTenantDTO(BaseModel):
    """
    ServicingProfileAssignedForAccessibleTenantDTO
    """ # noqa: E501
    profile_id: Optional[StrictStr] = Field(default=None, description="The unique identifier associated with the profile.", alias="profileId")
    display_name: Optional[StrictStr] = Field(default=None, description="An identifiable profile name to display in Visier such as \"Partner Service Manager\".", alias="displayName")
    tenant_code: Optional[StrictStr] = Field(default=None, description="The tenant code of the analytic tenant on which this profile is assigned.", alias="tenantCode")
    for_all_children: Optional[StrictBool] = Field(default=None, description="If true, the profile is assigned for all the analytic tenants of the administrating tenant.", alias="forAllChildren")
    validity_start_time: Optional[StrictStr] = Field(default=None, description="An inclusive date-time when this profile is active.   Note: Long.Min_Value means that startTime is undefined.", alias="validityStartTime")
    validity_end_time: Optional[StrictStr] = Field(default=None, description="An exclusive date-time when this profile is no longer active.   Note: Long.Max_Value means that endTime is undefined and is equivalent to permanent access.", alias="validityEndTime")
    __properties: ClassVar[List[str]] = ["profileId", "displayName", "tenantCode", "forAllChildren", "validityStartTime", "validityEndTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ServicingProfileAssignedForAccessibleTenantDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ServicingProfileAssignedForAccessibleTenantDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "profileId": obj.get("profileId"),
            "displayName": obj.get("displayName"),
            "tenantCode": obj.get("tenantCode"),
            "forAllChildren": obj.get("forAllChildren"),
            "validityStartTime": obj.get("validityStartTime"),
            "validityEndTime": obj.get("validityEndTime")
        })
        return _obj


